package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.context.VariableContext;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestOperation;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;

public interface OperationProcessor extends ClassResponder
{
	/**
	 * @param op
	 * @return handled if the operation was handled, reject to skip, and defer to allow a downstream
	 *         listener to evaluate.
	 * @throws TestAssertionFailure
	 *
	 * @throws TestExecutionError
	 * @throws TestWarning
	 */
	action_code process(ETLTestOperation op, ETLTestValueObject parameters, VariableContext vcontext, ExecutionContext econtext)
			throws TestAssertionFailure, TestExecutionError, TestWarning;
}