package org.bitbucket.bradleysmithllc.etlunit;

import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestClass;

import java.util.ArrayList;
import java.util.List;

public class TestClassResultImpl implements TestClassResult
{
	private final String className;
	private final ETLTestClass etlTestClass;

	private final List<TestMethodResult> testMethodResults = new ArrayList<TestMethodResult>();

	private final TestResultMetrics testResults = new TestResultMetricsImpl();

	public TestClassResultImpl(ETLTestClass etlc)
	{
		this.className = etlc.getName();
		etlTestClass = etlc;
	}

	@Override
	public String testClassName()
	{
		return className;
	}

	@Override
	public ETLTestClass getTestClass()
	{
		return etlTestClass;
	}

	@Override
	public TestResultMetrics getMetrics()
	{
		return testResults;
	}

	@Override
	public List<TestMethodResult> getMethodResults()
	{
		return testMethodResults;
	}
}