package org.bitbucket.bradleysmithllc.etlunit.feature.test_locator;

import com.google.inject.Injector;
import org.bitbucket.bradleysmithllc.etlunit.ClassLocator;
import org.bitbucket.bradleysmithllc.etlunit.DirectoryBasedClassLocatorImpl;
import org.bitbucket.bradleysmithllc.etlunit.feature.AbstractFeature;
import org.bitbucket.bradleysmithllc.etlunit.feature.FeatureModule;
import org.bitbucket.bradleysmithllc.etlunit.parser.ETLTestValueObject;
import org.bitbucket.bradleysmithllc.etlunit.util.Incomplete;

import java.io.File;
import java.util.Arrays;
import java.util.List;

@FeatureModule
public class DirectoryTestLocatorFeatureModule extends AbstractFeature
{
	private final List<String> prerequisites = Arrays.asList("logging");

	private DirectoryBasedClassLocatorImpl directoryBasedClassLocator = null;

	@Incomplete
	@Override
	public ClassLocator getLocator()
	{
		return directoryBasedClassLocator;
	}

	@Override
	public List<String> getPrerequisites()
	{
		return prerequisites;
	}

	@Override
	public void initialize(Injector inj)
	{
		ETLTestValueObject query = configuration.query("test-sources-directory");

		if (query == null)
		{
			throw new IllegalArgumentException("Configutation option 'test-sources-directory' not present.");
		}

		directoryBasedClassLocator = postCreate(new DirectoryBasedClassLocatorImpl(new File(query.getValueAsString())));
	}

	@Override
	public String getFeatureName()
	{
		return "directory-based-class-locator";
	}

	@Override
	public boolean requiredForSimulation() {
		return true;
	}
}