package org.bitbucket.bradleysmithllc.etlunit.util;

import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.core.JsonGenerator;
import com.fasterxml.jackson.core.util.DefaultPrettyPrinter;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.github.fge.jsonschema.exceptions.ProcessingException;
import com.github.fge.jsonschema.report.ProcessingMessage;
import com.github.fge.jsonschema.report.ProcessingReport;

import java.io.IOException;
import java.io.StringWriter;
import java.util.Iterator;

public class JsonProcessingUtil {
	public static String getProcessingReport(ProcessingReport report) {
		try {
			StringWriter stw = new StringWriter();

			JsonFactory jfact = new JsonFactory();

			JsonGenerator generator = jfact.createGenerator(stw);
			generator.setPrettyPrinter(new DefaultPrettyPrinter());
			generator.setCodec(new ObjectMapper());

			Iterator<ProcessingMessage> it = report.iterator();

			generator.writeStartObject();
			generator.writeStringField("document-type", "processing-report");

			generator.writeFieldName("processing-messages");

			generator.writeStartArray();

			while (it.hasNext()) {
				ProcessingMessage pm = it.next();

				generator.writeTree(pm.asJson());
			}

			generator.writeEndArray();
			generator.writeEndObject();
			generator.close();

			return stw.toString();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	public static String getProcessingReport(ProcessingException report) {
		try {
			StringWriter stw = new StringWriter();

			JsonFactory jfact = new JsonFactory();

			JsonGenerator generator = jfact.createGenerator(stw);
			generator.setPrettyPrinter(new DefaultPrettyPrinter());
			generator.setCodec(new ObjectMapper());

			generator.writeStartObject();
			generator.writeStringField("document-type", "processing-exception");

			generator.writeStringField("message", report.getMessage());
			generator.writeFieldName("processing-messages");

			generator.writeStartArray();

			generator.writeTree(report.getProcessingMessage().asJson());

			generator.writeEndArray();
			generator.writeEndObject();
			generator.close();

			return stw.toString();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}
}